- name: Create remote cluster
  uri:
    url: https://{{ config.elastic.fqdn }}/_cluster/settings
    method: "PUT"
    headers: "{{ kibana_rest_headers }}"
    body_format: json
    body: "{{ lookup( 'template', 'ccr_remote.json' ) }}"
    status_code: 200

- name: Check connection
  block:
    - name: Get status
      uri:
        url: https://{{ config.elastic.fqdn }}/_remote/info
        method: "GET"
        headers: "{{ kibana_rest_headers }}"
        status_code: 200
      register: cluster_info

    - name: Check connection
      assert:
        that:
          - cluster_info.json["{{ config.elastic.ccr.remote_cluster }}"].connected
        fail_msg: "The remote is not connected"

  # The replication role gets read and write privileges in order to support bi-directional replication
- name: Create/update remote-replication role for read and write
  uri:
    url: https://{{ config.elastic.fqdn }}/_security/role/remote-replication
    method: "PUT"
    headers: "{{ kibana_rest_headers }}"
    body_format: json
    body: 
      cluster:
        - read_ccr
        - manage_ccr
      indices:
        - names:
            - "*"
          privileges: 
            - monitor
            - read 
            - write 
            - manage_follow_index
    status_code: 200

  # Replication user is created according to elastic guide. Credentials of this user are never used. 
- name: Create/update cross-cluster-user 
  uri:
    url: https://{{ config.elastic.fqdn }}/_security/user/cross-cluster-user
    method: "PUT"
    headers: "{{ kibana_rest_headers }}"
    body_format: json
    body: 
      password: "{{ lookup('password', '/dev/null length=32 chars=ascii_letters') }}"
      roles:
        - remote-replication
    status_code: 200

